/*
 * Extra point No. 1: Runaway pointer (2 points in the final grade that can
 * apply to either programming assignment or exam, Due: Oct. 9, 11:59pm)
 *
 * Pointers in a linked list can easily cause problems. A buggy linked list 
 * program may create a loop in a linked list: the 'next' pointer in the tail 
 * of the list points back to one of the items in the list. In this challenge,
 * you will implement a routine 'int testloop (listnode *head)' 
 * to check whether the linked list 'head' contains a loop. If the linked list contains
 * a loop, testloop returns the size of the loop (the number of elements in the loop). 
 * Otherwise, testloop returns 0. The following are the requirements for the routine:
 *
 * (1) O(1) memory complexity.
 * (2) O(N) time complexity, where N is the length of the linked list.
 * (3) The routine should not modify the linked list.
 *
 * Briefly explain (informal proof) why your code has O(1) memory complexity
 * and O(N) time complexity. Put the analysis as comment in your program. 
 * (1.5 point for the code and 0.5 point for the analysis).
 *
 * Three files are given: main.cpp, create.o, and extra1.x. 
 * You can implement the testloop routine in main.cpp and compile
 * on linprog with 'g++ -o extra1.x main.cpp create.o'.
 */


// Created by Xin Yuan for COP4530
//
// to compile: g++ -o extra1.x main.cpp create.o
// to run: ./extra1.x
//
#include <iostream>

using namespace std;

class listnode {
public:
	listnode *next;
};

listnode *l[6];

// this is provided in the form of a .o file
void create_list();

// testloop checks whether the linked list has a loop
// return the number of elements in the loop if there is a loop
// return 0 otherwise
int testloop(listnode *head);

int main()
{

	int i;

	cout << "creating lists......\n";
	create_list(); // creating lists in *l[5]
	
	for (i=0; i<6; i++) {
		cout << "testing list " << i << " .....\n";
                int size = testloop(l[i]);
		if (size != 0) 
			cout << "    list " << i << " has a loop of size " << size << ".\n";
		else 
			cout << "    list " << i
			     << " does not have a loop.\n";
	}
}



